<template>
    <div>
        <div v-show="active" v-if="loaded" class="changelog__backdrop">
            <button @click="hide" class="absolute w-full h-full"></button>
            <div class="changelog-modal">
                <div class="changelog-modal__header">
                    <div class="changelog-modal__header__info">
                        <h4>{{ changelog.title }}</h4>
                        <div>{{ changelog.created_at }}</div>
                    </div>
                    <button @click="hide" class="changelog-modal__header__close">
                        <i class="fad fa-times fa-fw"></i>
                    </button>
                </div>

                <div class="changelog-modal__body">
                    <div class="changelog-modal__body__content">

                        <div class="changelog-modal__body__media">
                            <img :src="changelog.cover" alt="">
                        </div>
                        <static-editor-component static_editor_classes="editor__static" :content="changelog.content"></static-editor-component>
                    </div>
                </div>

                <div class="changelog-modal__footer">
                    <span> Missed an update?</span> <a href="https://kingsgaming.us/forums/board/annoucements-updates">Check out our previous changelogs</a>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        name: "ChangelogModal",
        props: [
            'signature'
        ],
        data() {
            return {
                active: false,
                changelog: null,
                loading: false,
                loaded: false,

            }
        },
        async mounted() {
            if (! this.loaded) {

                try {
                    // Grab info with $http / axios
                    // https://kingsgaming.us/api/changelog/actions/latest
                    //
                    const response = await this.$http.get(`https://kingsgaming.us/api/changelog/actions/latest`)

                    this.changelog = response.data

                    this.loaded = true

                    let localSignature = window.localStorage.getItem('signature');

                    if (this.signature !== localSignature) {
                        this.show();
                        window.localStorage.setItem('signature', this.signature);
                    }

                } catch (error) {
                    this.loaded = false

                    this.hide()
                }
            }
        },
        methods: {
            show() {
                let body = document.getElementById('body');
                body.classList.remove('scrollable')

                this.active = true;
            },
            hide() {
                let body = document.getElementById('body');
                body.classList.add('scrollable')

                this.active = false;
            }
        }
    }
</script>

<style lang="scss" scoped>
    .changelog__backdrop {
        z-index: 1000;
        background: rgba(0, 0, 0, 0.4);

        @apply fixed inset-0 w-full h-full flex items-center justify-center;
    }


    .changelog-modal {
        width: 490px;
        max-height: 800px;
        background: radial-gradient(circle at top left, rgba(57,57,71, 0.4) 0%, rgba(57,57,71, 0) 60%), rgba(41,41,51, 1);
        border-image: linear-gradient(to right, #47bfff 0%, #1a44c2 60%) 25%;
        z-index: 9999;

        @apply relative break-words whitespace-pre-wrap border-t-2;
    }

    .changelog-modal__header{
        @apply relative overflow-hidden z-10 p-6 flex flex-no-wrap justify-start;;
    }

    .changelog-modal__header__info {
        @apply mr-4 flex-auto;

        h4 {
            @apply text-white font-bold font-display-1 cursor-default;
        }

        div {
            @apply text-neutral-200;
        }
    }

    .changelog-modal__header__close {
        height: 25px;

        @apply ml-4 text-neutral-050 opacity-50 rounded;

        &:hover {
            @apply opacity-100;
        }
    }

    .changelog-modal__body {
        max-height: 440px;

        @apply relative flex flex-auto h-full text-neutral-100;
    }

    .changelog-modal__body__content {
        @apply overflow-x-hidden flex-1 overflow-y-scroll pb-6 px-6;
    }

    .changelog-modal__body__media {

        // w-450px h-250px
        @apply shadow rounded;
    }

    .changelog-modal__footer {
        @apply p-6 text-sm text-center text-neutral-100 flex items-center justify-center;

        span {
            @apply mr-2;
        }


        a {
            @apply text-primary-500;
        }
    }
</style>
